Unit ASH1CT_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASH1CT(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer);

implementation

procedure ASH1CT(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer);
var
IW,I,IM1,K,N1,II,IS_,IQ,KK,IP :Integer;
T :Complex;
const
ZERO :Real = 0.0E0;
label
_1,_2,_3,_4,_5,_6,_7;
begin
IP := 1;
IW := 0;
for I:=1 to N do
 begin
  T := B[I-1];
  IM1 := I-1;
  if ( IW = 0 ) 
   then goto _2;
  IP := IP+IW-1;
  for K:=IW to IM1 do
   begin
    T := SubC(T,MulC(A[IP-1],X[K-1]));
    IP := IP+1;
_1:
   end;
  goto _3;
_2:
  if ( Cabs(T) <> ZERO ) 
   then IW := I;
  IP := IP+IM1;
_3:
  X[I-1] := DivC(T,A[IP-1]);
  IP := IP+1;
_4:
 end;
N1 := N+1;
for I:=1 to N do
 begin
  II := N1-I;
  IP := IP-1;
  IS_ := IP;
  IQ := II+1;
  T := X[II-1];
  if ( N < IQ ) 
   then goto _6;
  KK := N;
  for K:=IQ to N do
   begin
    T := SubC(T,MulC(Conjg(A[IS_-1]),X[KK-1]));
    KK := KK-1;
    IS_ := IS_-KK;
_5:
   end;
_6:
  X[II-1] := DivC(T,Conjg(A[IS_-1]));
_7:
 end;
end;

end.
